import { Utils } from '@singularsystems/neo-core';
import { configure, isObservableArray, runInAction, untracked } from 'mobx';
import React from 'react';
export function runReactSetup(container) {
    Utils.peek = function (target, propertyName) {
        return untracked(function () { return target[propertyName]; });
    };
    Utils.suppressHtmlEncode = function (html) {
        return React.createElement("div", { dangerouslySetInnerHTML: { __html: html } });
    };
    Utils.batchUpdate = runInAction;
    Utils.sortableArray = function (array) {
        if (isObservableArray(array)) {
            return array.slice();
        }
        return array;
    };
    configure({ enforceActions: "never", useProxies: "never" });
}
