import { AppServices } from '@singularsystems/neo-core';
import { INavigationHelper } from '../Routing/NavigationHelper';
import { RoutingState } from '../Routing/RoutingState';
import { SketchPicker } from 'react-color';
import { IColorPicker } from '../ReactComponents/IColorPicker';
import type AsyncSelect from 'react-select/async';
import { AxiosStatic } from 'axios';
import type Select from 'react-select';
import { IDisposeHelper } from '../Services/IDisposeHelper';
import { IIconFactory } from '../ReactComponents/Icons/IIconFactory';
import { IPageLeaveHandler } from "../Routing/PageLeaveHandler";
declare const NeoReactTypes: {
    Components: {
        Slider: AppServices.ServiceIdentifier<import("react").ForwardRefExoticComponent<import("rc-slider").SliderProps<number | number[]> & import("react").RefAttributes<import("rc-slider").SliderRef>>>;
        /**
         * Sketchpicker (from 'react-color' package) component used by the color picker.
         * It is recommended to use the `ColorPicker` type and bind to HexColorPicker from the 'react-colorful' package.
         */
        SketchPicker: AppServices.ServiceIdentifier<typeof SketchPicker>;
        /**
         * Returns a component that renders a color picker that accepts a color input, and onChange event handler.
         */
        ColorPicker: AppServices.ServiceIdentifier<IColorPicker>;
        ReactSelect: AppServices.ServiceIdentifier<Select>;
        AsyncSelect: AppServices.ServiceIdentifier<AsyncSelect>;
        IconFactory: AppServices.ServiceIdentifier<IIconFactory>;
    };
    Routing: {
        PageLeaveHandler: AppServices.ServiceIdentifier<IPageLeaveHandler>;
        NavigationHelper: AppServices.ServiceIdentifier<INavigationHelper>;
        GlobalRoutingState: AppServices.ServiceIdentifier<RoutingState>;
        MenuItemProvider: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Routing").IMenuItemProvider<import("@singularsystems/neo-core/dist/Routing").IMenuRoute>>;
        RouteSecurityService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Routing").IRouteSecurityService>;
    };
    Services: {
        DisposeHelper: AppServices.ServiceIdentifier<IDisposeHelper>;
    };
    Axios: AppServices.ServiceIdentifier<import("axios").AxiosStatic>;
    Config: {
        ConfigModel: AppServices.ServiceIdentifier<AppServices.IConfigModel>;
        ConfigService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/AppServices/Config/ConfigService").IConfigService>;
    };
    Core: {
        AutoRunnerFactory: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Model/IAutoRunner").IAutoRunnerFactory>;
        ConnectionManager: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/ConnectionManager").IConnectionManager>;
        DecimalService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Numeric").IDecimalService<import("@singularsystems/neo-core/dist/Numeric").IDecimal>>;
        ModelCreator: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Model/IModelCreatorBase").default>;
    };
    Localisation: {
        LocalisationService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Localisation").ILocalisationService>;
    };
    Messaging: {
        ConnectionManager: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/ConnectionManager").IConnectionManager>;
        ServerMessageSubscriber: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/SignalR").IServerMessageSubscriber>;
    };
    Security: {
        AuthenticationService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Security").IAuthenticationService>;
        AuthorisationService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Security").IAuthorisationService>;
        LoginErrorHandler: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Security").ILoginErrorHandler>;
        SecurityService: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Security/ISecurityService").default>;
    };
    TaskRunner: AppServices.ServiceIdentifier<import("@singularsystems/neo-core").ITaskRunner>;
    UI: {
        ErrorHandler: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components").IErrorHandler>;
        GlobalContextMenuState: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components/ContextMenu/ContextMenu").IContextMenuState>;
        GlobalNotifications: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components").INotificationHelper>;
        ModalStore: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components/Modal/ModalStore").IModalStore>;
        NotificationHelper: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components").INotificationHelper>;
        NotificationStore: AppServices.ServiceIdentifier<import("@singularsystems/neo-core/dist/Components").INotificationStore>;
    };
};
export { NeoReactTypes };
