import { createObservableList } from './Utils';
/**
 * Makes a list observable. Use this only when the property is not part of a NeoModel. E.g. it is defined directly on a component.
 */
export function observableList(type, propertyKey) {
    var descriptor = arguments[2];
    var initializer = descriptor.initializer;
    return {
        get: function () {
            // Convert to observable list on first read. This will overwrite this getter, and the next read will call the overwritten get method.
            createObservableList(this, propertyKey, initializer());
            return this[propertyKey];
        }
    };
}
