import { observable } from "mobx";
import { List } from '@singularsystems/neo-core';
export function createObservableList(target, propertyKey, list) {
    if (list instanceof Array) {
        // this overload is not part of the typescript typings. The true tells it to create the observable immediately
        observable.shallow(target, propertyKey, { value: list }, true);
        // add the original methods and values back to the mobx array.
        var obsArray = target[propertyKey];
        List.copyMethods(obsArray);
        list.setupProxy(obsArray, target, propertyKey);
    }
    else {
        throw "observableList can only be defined on arrays.";
    }
}
