import { __assign, __decorate, __extends, __metadata, __rest } from "tslib";
import React from 'react';
import { observer } from 'mobx-react';
import { Utils } from '@singularsystems/neo-core';
import BootstrapUtils from "./BootstrapUtils";
var Badge = /** @class */ (function (_super) {
    __extends(Badge, _super);
    function Badge(props) {
        return _super.call(this, props) || this;
    }
    Badge.prototype.render = function () {
        var _a, _b;
        var _c = this.props, text = _c.text, variant = _c.variant, customVariant = _c.customVariant, isLarge = _c.isLarge, isPill = _c.isPill, children = _c.children, domProps = __rest(_c, ["text", "variant", "customVariant", "isLarge", "isPill", "children"]);
        var isBsPre5 = BootstrapUtils.isPre5;
        var variantClassName = isBsPre5 ? "badge badge-".concat(((_a = customVariant !== null && customVariant !== void 0 ? customVariant : variant) !== null && _a !== void 0 ? _a : "primary")) : "badge bg-".concat(((_b = customVariant !== null && customVariant !== void 0 ? customVariant : variant) !== null && _b !== void 0 ? _b : "primary"));
        var largeBadgeClassName = isLarge ? "badge-lg" : "";
        var pillClassName = isPill ? (isBsPre5 ? "badge-pill" : "rounded-pill") : "";
        domProps.className = Utils.joinWithSpaces(domProps.className, variantClassName, pillClassName, largeBadgeClassName);
        return (React.createElement("div", __assign({}, domProps), children !== null && children !== void 0 ? children : text));
    };
    Badge = __decorate([
        observer,
        __metadata("design:paramtypes", [Object])
    ], Badge);
    return Badge;
}(React.Component));
export default Badge;
