import { Components } from "@singularsystems/neo-core";
import React, { MouseEventHandler } from "react";
declare class BootstrapUtils {
    constructor();
    private breakPoints;
    /** Bootstrap version is before v5 */
    get isPre5(): boolean;
    /** Class prefix (without -) for start margin / left margin. */
    get marginS(): "ml" | "ms";
    /** Class prefix (without -) for end margin / right margin. */
    get marginE(): "mr" | "me";
    /**
     * Gets the close button used in component headers.
     * @param pre5ClassName Class to add if bootstrap version is <5.
     */
    getCloseButton(onClick: MouseEventHandler<HTMLButtonElement>, pre5ClassName?: string): React.JSX.Element;
    getBreakpoints(): Components.IBootstrapSizes<number>;
    currentDimension<T>(props: Partial<Components.IBootstrapSizes<T>>): T | undefined;
}
declare const _default: BootstrapUtils;
export default _default;
