import * as React from 'react';
import ComponentBase from './ComponentBase';
import { Components } from '@singularsystems/neo-core';
type IButtonProps = Components.IButtonOptions & Omit<React.DetailedHTMLProps<React.ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement>, "ref" | "onClick"> & React.RefAttributes<Button>;
interface IButtonState {
    isExpanded: boolean;
}
export default class Button extends ComponentBase<IButtonProps, IButtonState> {
    state: {
        isExpanded: boolean;
    };
    btnGroupDom: React.RefObject<HTMLDivElement | null>;
    menuDom: React.RefObject<HTMLDivElement | null>;
    private iconFactory;
    private windowClickHandler;
    private positionHelper?;
    constructor(props: IButtonProps);
    showMenu(): void;
    hideMenu(): void;
    private menuItemClicked;
    private windowClicked;
    afterRender(): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<unknown, string | React.JSXElementConstructor<any>>;
    protected suppressIcon(icon: any): boolean;
}
export {};
