import React, { JSX } from 'react';
import { Model } from '@singularsystems/neo-core';
interface ICardProps {
    /** Icon to show next to title in header. */
    icon?: string;
    /** Title to show in header. */
    title?: any;
    /** Header elements to show on right hand side of header. */
    headerElements?: JSX.Element;
    /** Footer elements to show on bottom of the card. */
    footerContent?: JSX.Element;
    /** Use a custom scrollbar instead of the browser scrollbar. */
    useCustomScrollbar?: boolean;
    /** Causes the card to be collapsible. Adds a collapse icon to the header. */
    collapsible?: boolean;
    /** Causes the card to be collapsed on first render. Sets the collapsible prop to true. */
    initiallyCollapsed?: boolean;
    /** Allows the collapse state to be set externally. Sets the collapsible prop to true. */
    isExpanded?: Model.IObservableValue<boolean>;
    /** Indicates whether the icon should be on the right of the header (default), or left of the icon/title. */
    expandIconPosition?: "none" | "left" | "right";
}
export default class Card extends React.Component<ICardProps & React.HTMLProps<HTMLDivElement>> {
    private iconFactory;
    private expandState;
    render(): JSX.Element;
}
export {};
