import { Components } from '@singularsystems/neo-core';
import React from 'react';
import ComponentBase from './ComponentBase';
interface ICollapsableProps extends React.HTMLProps<HTMLDivElement> {
    /**
     * True if the div should be visible.
     */
    show: boolean;
    /** Callback to show */
    onHidden?: () => void;
}
/**
 * Renders a div that shows and hides using a vertical collapse animation.
 * Uses the collapsable and collapsed css classes.
 */
export default class Collapsable extends ComponentBase<ICollapsableProps> {
    protected containerRef: React.RefObject<HTMLDivElement | null>;
    protected animationHelper?: Components.CollapseAnimationHelper;
    render(): React.JSX.Element;
    afterRender(isInitial: boolean): void;
    componentWillUnmount(): void;
}
export {};
