import React from "react";
export interface IComponentBase {
    uniqueId: number;
}
export default class ComponentBase<TProps, TState = {}> extends React.Component<TProps, TState> implements IComponentBase {
    private static globalCounter;
    private isFirstRender;
    uniqueId: number;
    componentDidMount(): void;
    componentDidUpdate(): void;
    /** To be overidden in sub class */
    protected onFirstRender(): void;
    /** To be called by sub class in render method */
    protected onRender(): void;
    /** To be overidden in sub class */
    protected afterRender(isInitial: boolean): void;
}
