import React from 'react';
import { Components } from '@singularsystems/neo-core';
import ComponentBase from '../ComponentBase';
import { IPosition } from '@singularsystems/neo-core/dist/Components/ContextMenu/ContextMenu';
export interface IContextMenuProps {
    menuItems: Components.IMenuItem[];
    show?: boolean;
    /**
     * Position relative to screen.
     */
    position?: IPosition;
    /**
     * Called when a menu item is clicked. Use to hide the context menu.
     */
    onClick?: () => void;
}
export default class ContextMenu extends ComponentBase<IContextMenuProps> {
    constructor(props: IContextMenuProps);
    private iconFactory;
    private menuRef;
    private hoverItem;
    mouseEnter(e: React.MouseEvent<HTMLDivElement>, item: Components.IMenuItem): void;
    afterRender(): void;
    render(): React.JSX.Element;
}
