import * as React from 'react';
import { IBindableEditorProps } from './PropTypes';
import { Components } from '@singularsystems/neo-core';
import ComponentBase from './ComponentBase';
import { FormContext } from './FormContext';
export interface INeoDatePickerProps extends IBindableEditorProps<HTMLInputElement> {
    dateProps?: Components.IPartialDateProps;
}
export default class DatePicker extends ComponentBase<INeoDatePickerProps> {
    static contextType: React.Context<import("./FormContext").FormContextParams>;
    context: React.ContextType<typeof FormContext>;
    private container;
    private datePicker?;
    private isReadOnly;
    private inputRef;
    constructor(props: INeoDatePickerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): React.JSX.Element;
}
