import { Data, Model } from '@singularsystems/neo-core';
import ComponentBase from '../ComponentBase';
export type ItemSource<T> = T[] | Promise<T[]> | Data.IAsyncDataSource<T[]> | Data.IArrayCacheEntry<T>;
export declare abstract class DropDownBase<T, TProps> extends ComponentBase<TProps> {
    protected valueMember: keyof T;
    protected displayMember: keyof T;
    protected findMembers(item: any): void;
    protected isLoading: boolean;
    protected dataSource: Data.IAsyncDataSource<T[]> | null;
    protected cachedDataSource: Data.IDataCacheEntry | null;
    protected fieldInfoContainer: Model.IModelFieldInfoContainer | null;
    protected getItems(itemSource: ItemSource<T>): T[];
    afterRender(isInitial: boolean): Promise<void>;
    private fieldDisplayInfo;
    protected setFieldInfo(bindProperty: Model.IPropertyInstance, displayValue: string, readableName?: string): void;
}
