export interface ILookupMembers<T> {
    valueMember: keyof T;
    displayMember: keyof T;
}
export default class LookupHelper {
    /**
     * Finds the value and display member of a class by convention.
     * Also uses the displayMember attribute if defined on any of the properties.
     * @param item An object instance
     * @param booleanValuesAllowed True if boolean values are allowed in the value member.
     */
    static findMembers<T>(item: any, valueMember: keyof T, displayMember: keyof T, booleanValuesAllowed?: boolean): ILookupMembers<T>;
}
