import React from 'react';
import { Components } from "@singularsystems/neo-core";
import { FileContext } from './FileContext';
interface IFileInputProps extends React.HTMLProps<HTMLInputElement> {
    fileManager?: Components.IFileManager;
    isHidden?: boolean;
    inputRef?: React.RefObject<HTMLInputElement | null>;
}
/**
 * Renders an input[type=file] input bound to a file manager.
 */
export default class FileBasicInput extends React.Component<IFileInputProps> {
    static contextType: React.Context<import("./FileContext").IFileContextProps>;
    context: React.ContextType<typeof FileContext>;
    private fileManager;
    constructor(props: IFileInputProps);
    private onFileSelected;
    render(): React.JSX.Element;
}
export {};
