import React from 'react';
import { Components } from '@singularsystems/neo-core';
export interface IFileComponentProps {
    /** File manager instance. Props that can be specified in file manager options will be ignored on this component. */
    fileManager?: Components.IFileManager;
    /** Upload endpoint. This is required when not using a file manager. */
    uploadEndpoint?: string;
    children?: React.ReactNode;
}
export interface IFileContextProps {
    fileManager?: Components.IFileManager;
}
export declare const FileContext: React.Context<IFileContextProps>;
export default class FileContextProvider extends React.Component<IFileComponentProps & (Partial<Components.IFileManagerOptions> | Partial<Components.IBoundFileManagerOptions>)> {
    render(): React.JSX.Element;
}
