import * as React from 'react';
import { Components, Model } from '@singularsystems/neo-core';
interface IFormProps<T extends Model.IModelBase> extends Omit<React.FormHTMLAttributes<HTMLElement>, "children">, Components.IFormOptions<T> {
    /**
     * Called when the form is submitted, but the model is not valid.
     * The firstSubmit parameter will be true if this is the first submit attempt for the model.
     */
    onInvalid?: (e?: React.FormEvent, firstSubmit?: boolean) => void;
    children: React.ReactNode | ((item: T, meta: Model.TransformMetaType<T>) => React.ReactNode);
}
export default class Form<T extends Model.IModelBase> extends React.Component<IFormProps<T>> {
    private reactionDisposer?;
    private getModelOrModels;
    private onSubmit;
    /** Checks if the model is valid, waiting for any async rules to complete. Returns true if the model is valid. */
    validateAsync(): Promise<boolean>;
    private disposeReaction;
    componentWillUnmount(): void;
    render(): React.JSX.Element;
}
export {};
