import React from 'react';
import { Components, Model, Validation } from '@singularsystems/neo-core';
export declare enum EditorParentType {
    FormGroup = 1,
    Column = 2
}
export declare class FormContextParams implements Components.IFormContextOptions {
    /** The validation display mode to apply to all controls. */
    validationDisplayMode: Validation.DisplayMode;
    /** True if all controls in this section should be readonly. */
    allReadOnly: boolean;
    /** True if all controls in this section should be disabled. */
    allDisabled: boolean;
    /** True if all labels should be hidden. */
    suppressLabels?: boolean;
    /**
     * The property the form group is bound to.
     */
    bindProperty: Model.IPropertyInstance;
    parentType: EditorParentType;
    uniqueId?: string;
}
export declare const FormContext: React.Context<FormContextParams>;
/**
 * Allows the attributes of multiple child form controls to be set at a parent level.
 */
export declare class FormContextProvider extends React.Component<Components.IFormContextOptions & {
    children: React.ReactNode;
}> {
    static contextType: React.Context<FormContextParams>;
    context: React.ContextType<typeof FormContext>;
    render(): React.JSX.Element;
}
