import * as React from 'react';
import { IEditorContainerProps } from '../PropTypes';
import ComponentBase from '../ComponentBase';
import { FormContext } from '../FormContext';
export interface IFormGroupProps<TData> extends IEditorContainerProps<HTMLDivElement, TData> {
    /**
     * Properties to apply to the label.
     */
    labelProps?: React.HTMLProps<HTMLLabelElement>;
    /**
     * Hides the label.
     */
    suppressLabel?: boolean;
    /**
     * Text to show beneath the editor. This will be hidden when validation text is shown.
     */
    footerText?: string | React.ReactNode;
    /**
     * Text / element to show to the right of the label.
     */
    rightLabel?: string | React.ReactNode;
}
export interface IFormGroupClasses {
    container: string;
    containerDom: React.HTMLProps<HTMLDivElement>;
    label: string;
    editor: string;
}
export declare class FormGroupBase<T extends IFormGroupProps<TData>, TData> extends ComponentBase<T> {
    static contextType: React.Context<import("../FormContext").FormContextParams>;
    context: React.ContextType<typeof FormContext>;
    protected isBsPre5: boolean;
    protected getFormGroupClasses(domProps: React.HTMLProps<HTMLDivElement>, isCheckBox: boolean): IFormGroupClasses;
    protected hideLabelForCheckboxes(): boolean;
    render(): React.JSX.Element;
}
export default class FormGroup<TData> extends FormGroupBase<IFormGroupProps<TData>, TData> {
}
