import React from 'react';
import { FormContext } from '../FormContext';
import type { IEditorContainerProps } from '../PropTypes';
import ComponentBase from '../ComponentBase';
export default class FloatingFormGroup<TData> extends ComponentBase<IEditorContainerProps<HTMLDivElement, TData>> {
    static contextType: React.Context<import("../FormContext").FormContextParams>;
    context: React.ContextType<typeof FormContext>;
    private originalOnFocus?;
    private originalOnBlur?;
    private isFocused;
    private placeholder?;
    constructor(props: IEditorContainerProps<HTMLDivElement, TData>);
    private containerRef;
    private editorRef;
    private onFocus;
    private onBlur;
    private labelClick;
    render(): React.JSX.Element;
}
