import React from 'react';
import { Components } from '@singularsystems/neo-core';
interface ILayoutGridProps extends Components.IColumnCountBreakpoints {
    /** Size of gutters between columns. 1 - 5. */
    gutterSize?: Components.gutterSize;
    /** Vertical space to insert between rows. Specify using a css dimension. */
    verticalSpace?: string;
    /** Sets verticalSpace to "1rem" for convenience. */
    withGaps?: boolean;
    /** Alignment of items vertically */
    alignItems?: Components.flexItemAlign;
    /** Sets dynamic horizontal spacing. If this is set, normal column spacing is ignored.  */
    justifyContent?: Components.flexJustifyContent;
    formGroupProps?: Components.IColumnWidthBreakpoints;
    /** Arranges child elements vertically rather than horizontally. */
    arrangeVertically?: boolean;
}
export declare class FormGroupLayoutContextParams {
    formGroupProps?: Components.IColumnWidthBreakpoints;
}
export declare const FormGroupLayoutContext: React.Context<FormGroupLayoutContextParams>;
export default class GridLayout extends React.Component<ILayoutGridProps & React.HTMLProps<HTMLDivElement>> {
    render(): React.JSX.Element;
}
export {};
