import { __assign, __extends, __rest } from "tslib";
import React from 'react';
import { Utils } from '@singularsystems/neo-core';
import BootstrapUtils from "./BootstrapUtils";
var FormGroupLayoutContextParams = /** @class */ (function () {
    function FormGroupLayoutContextParams() {
    }
    return FormGroupLayoutContextParams;
}());
export { FormGroupLayoutContextParams };
export var FormGroupLayoutContext = React.createContext(new FormGroupLayoutContextParams());
var GridLayout = /** @class */ (function (_super) {
    __extends(GridLayout, _super);
    function GridLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GridLayout.prototype.render = function () {
        var _a;
        var _b = this.props, gutterSize = _b.gutterSize, verticalSpace = _b.verticalSpace, withGaps = _b.withGaps, alignItems = _b.alignItems, justifyContent = _b.justifyContent, formGroupProps = _b.formGroupProps, arrangeVertically = _b.arrangeVertically, xs = _b.xs, sm = _b.sm, md = _b.md, lg = _b.lg, xl = _b.xl, xxl = _b.xxl, domProps = __rest(_b, ["gutterSize", "verticalSpace", "withGaps", "alignItems", "justifyContent", "formGroupProps", "arrangeVertically", "xs", "sm", "md", "lg", "xl", "xxl"]);
        var isBsPre5 = BootstrapUtils.isPre5;
        var hasColumns = (xs || sm || md || lg || xl || xxl);
        var columnClassName = undefined;
        var isJustifyBetween = justifyContent === "between";
        var baseRowClassName = "row";
        if (!justifyContent) {
            columnClassName = Utils.joinWithSpaces((gutterSize !== undefined && isBsPre5) ? "px-" + gutterSize : undefined, xs && "col-" + 12 / xs, sm && "col-sm-" + 12 / sm, md && "col-md-" + 12 / md, lg && "col-lg-" + 12 / lg, xl && "col-xl-" + 12 / xl, xxl && "col-xxl-" + 12 / xxl);
            if (!hasColumns) {
                columnClassName = Utils.joinWithSpaces(columnClassName, "col-md-6");
            }
        }
        else {
            if (hasColumns) {
                console.error("GridLayout: Columns should not be specified if justifyContent is specified.");
            }
            baseRowClassName = "d-flex justify-content-" + justifyContent;
        }
        var rowClassName = Utils.joinWithSpaces(domProps.className, baseRowClassName, gutterSize && (isBsPre5 ? "mx-n" : "gx-") + gutterSize, alignItems && "align-items-" + alignItems);
        var containerStyle = domProps.style;
        var columnStyle = { marginLeft: "auto" };
        if (withGaps && !verticalSpace) {
            verticalSpace = "1rem";
        }
        if (verticalSpace) {
            containerStyle = containerStyle || {};
            containerStyle.marginTop = "-" + verticalSpace;
            columnStyle = { marginTop: verticalSpace, marginLeft: "auto" };
        }
        var childItems = React.Children.toArray(this.props.children).filter(function (c) { return !!c; });
        var childCount = childItems.length;
        if (arrangeVertically) {
            var maxColumns = (_a = BootstrapUtils.currentDimension(this.props)) !== null && _a !== void 0 ? _a : 2;
            var itemsPerRow = Math.ceil(childCount / maxColumns);
            var rows = [];
            for (var i = 0; i < maxColumns; i++) {
                BootstrapUtils;
                rows.push(React.createElement("div", { key: i }, childItems.splice(0, itemsPerRow)));
            }
            childItems = rows;
        }
        return (React.createElement(FormGroupLayoutContext.Provider, { value: { formGroupProps: formGroupProps } },
            React.createElement("div", __assign({}, domProps, { className: rowClassName, style: containerStyle }), childItems.map(function (child, index) { return (child && React.createElement("div", { key: index, className: columnClassName, style: __assign(__assign({}, columnStyle), { marginLeft: childCount === 2 && index === 1 && isJustifyBetween ? "auto" : undefined }) }, child)); }))));
    };
    return GridLayout;
}(React.Component));
export default GridLayout;
