import React from "react";
import { IconFactory } from "./IconFactory";
import { IconStyle } from "./IIconFactory";
interface IconDefinition {
    iconName: string;
}
interface FontAwesomeIconComponentProps {
    icon: any;
    fixedWidth?: boolean;
    spin?: boolean;
}
type FontAwesomeComponent = (props: FontAwesomeIconComponentProps) => React.ReactNode;
/** Icon factory supporting font-awesome string, as well as the font-awesome icon definition and component. */
export declare class FontAwesomeIconFactory extends IconFactory {
    private fontAwesomeComponentType;
    /**
     * Creates a font awesome factory, allowing the use of IconDefinition on any neo icon prop.
     * @param fontAwesomeComponentType import { FontAwesomeIcon } from '@fortawesome/react-fontawesome';
     */
    constructor(fontAwesomeComponentType: FontAwesomeComponent);
    protected createIconComponent(iconComponent: IconDefinition | React.ReactNode, iconStyle?: IconStyle): React.ReactNode;
}
export {};
