import React from "react";
import { IconFactory, IconStyle } from ".";
interface IMaterialSymbolsOptions {
    /** Set to true if icon names with unspecified fill should be made solid/filled. */
    fillDefault?: boolean;
    /** Additional mappings between font-awesome, and material symbols. */
    fontAwesomeMappings?: [string, string][];
    /** Set to true if the provided mappings should completely replace the built in neo mappings. */
    replaceNeoMappings?: boolean;
}
/**
 * Font factory that renders google material symbols icons.
 */
export declare class MaterialSymbolsFontFactory extends IconFactory {
    constructor(options?: IMaterialSymbolsOptions);
    private filledByDefault;
    private fontAwesomeMap;
    protected mapStringToIcon(iconName: string, style?: IconStyle | undefined): React.ReactNode;
    protected mapFontAwesomeToMaterial(faName: string): string | undefined;
}
export {};
