import React from 'react';
import { Misc } from '@singularsystems/neo-core';
import { NeoReactTypes } from '../Modules/Types';
var InputHelpers = /** @class */ (function () {
    function InputHelpers() {
    }
    InputHelpers.surroundWithInputGroup = function (element, props, domProps, inputRef) {
        if (!this.iconFactory) {
            this.iconFactory = Misc.Globals.appService.get(NeoReactTypes.Components.IconFactory);
        }
        if (props.requiresGroup) {
            var isDisabled = domProps.disabled || domProps.readOnly;
            return (React.createElement("div", { className: "input-group" + (isDisabled ? " input-group-disabled" : "") },
                this.getElement("input-group-prepend", inputRef, props.prependText, props.prependIcon, props.prepend),
                element,
                this.getElement("input-group-append", inputRef, props.appendText, props.appendIcon, props.append)));
        }
        else {
            return element;
        }
    };
    InputHelpers.getElement = function (className, inputRef, text, icon, element) {
        if (!text && !icon && !element) {
            return undefined;
        }
        var innerElement = element ?
            (element instanceof Function ? element() : element) :
            React.createElement("span", { className: "input-group-text", onClick: function () { var _a; return (_a = inputRef === null || inputRef === void 0 ? void 0 : inputRef.current) === null || _a === void 0 ? void 0 : _a.focus(); } }, text ? this.iconFactory.textOrIcon(text) : this.iconFactory.getIconComponent(icon));
        return React.createElement("div", { className: className }, innerElement);
    };
    return InputHelpers;
}());
export { InputHelpers };
