import React from 'react';
interface ILinkProps extends React.HTMLProps<HTMLAnchorElement> {
    /** Internal path to navigate to. */
    to?: string;
    /** Indicates that this link is part of a navigation structure, and will be active if it matches the current url. */
    isNav?: boolean;
    /** If `isNav` is set, then this will cause the url to match exactly instead of using startswith. */
    exact?: boolean;
}
/**
 * Renders an anchor tag with an href of '/' unless otherwise specified.
 * The onClick event will call preventDefault() so that the anchor acts like a button instead of a link to a url.
 */
export default class Link extends React.Component<ILinkProps> {
    private basePath;
    constructor(props: ILinkProps);
    private onClick;
    render(): React.JSX.Element;
}
export {};
