import React from "react";
import { ITaskRunner } from '@singularsystems/neo-core';
import ComponentBase from './ComponentBase';
interface ILoaderProps extends React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement> {
    show?: boolean;
    task?: ITaskRunner;
    showSpinner?: boolean;
    /** Set to override the normal size of the spinner. */
    size?: "small";
}
export default class Loader extends ComponentBase<ILoaderProps> {
    overlayRef: React.RefObject<HTMLDivElement | null>;
    isShowing: boolean;
    hasAnimated: boolean;
    render(): React.JSX.Element;
    afterRender(): void;
}
export {};
