export interface ICancellableEvent {
    /** Informs the caller to cancel any further actions or processing. */
    cancel(): void;
    /** Continues with the original action. */
    continue(): void;
}
export declare class CancellableEvent implements ICancellableEvent {
    private canContinue;
    private hasCancelled;
    private cancelledAction?;
    constructor(canContinue: () => boolean);
    cancel(): void;
    tryRunAction(action: () => void): void;
    continue(): void;
}
