import { __assign, __decorate, __extends, __rest } from "tslib";
import React from "react";
import { Misc, Utils } from "@singularsystems/neo-core";
import { observer } from 'mobx-react';
import CollapsableBase from '../CollapsableBase';
import { NeoReactTypes } from "../../Modules/Types";
import BootstrapUtils from "../BootstrapUtils";
var Alert = /** @class */ (function (_super) {
    __extends(Alert, _super);
    function Alert() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.iconFactory = Misc.Globals.appService.get(NeoReactTypes.Components.IconFactory);
        return _this;
    }
    Alert.prototype.render = function () {
        var _a;
        var _b = this.props, variant = _b.variant, heading = _b.heading, show = _b.show, bindShow = _b.bindShow, autoCloseTimeout = _b.autoCloseTimeout, animateInitial = _b.animateInitial, state = _b.state, onHidden = _b.onHidden, refreshValue = _b.refreshValue, icon = _b.icon, isOutline = _b.isOutline, native = __rest(_b, ["variant", "heading", "show", "bindShow", "autoCloseTimeout", "animateInitial", "state", "onHidden", "refreshValue", "icon", "isOutline"]);
        isOutline !== null && isOutline !== void 0 ? isOutline : (isOutline = Misc.Settings.alerts.isOutline);
        var iconPosition = (_a = this.props.iconPosition) !== null && _a !== void 0 ? _a : Misc.Settings.alerts.iconPosition;
        var className = Utils.joinWithSpaces(native.className, "alert", "alert-" + variant, "collapsable" + (isOutline ? " alert-outline" : "") + (iconPosition === "left" ? " alert-left-icon" : ""));
        if (bindShow) {
            className += " alert-dismissible";
        }
        if (heading) {
            className += " with-heading";
        }
        this.shouldShow = show !== false && (!bindShow || bindShow.value);
        return (React.createElement("div", __assign({}, native, { className: className, ref: this.containerRef }),
            bindShow && BootstrapUtils.getCloseButton(this.onClose),
            iconPosition === "body" &&
                React.createElement(React.Fragment, null,
                    heading &&
                        React.createElement("h6", null, heading),
                    icon &&
                        React.createElement("div", { className: "notification-icon-container" },
                            this.iconFactory.getIconComponent(icon),
                            React.createElement("div", null, this.props.children)),
                    !icon && this.props.children),
            iconPosition === "left" &&
                React.createElement("div", null,
                    icon &&
                        React.createElement("div", { className: "notification-icon-container" }, this.iconFactory.getIconComponent(icon)),
                    React.createElement("div", null,
                        heading && React.createElement("h6", null, heading),
                        React.createElement("div", { className: "alert-body" }, this.props.children)))));
    };
    Alert = __decorate([
        observer
    ], Alert);
    return Alert;
}(CollapsableBase));
export default Alert;
