import React from 'react';
import { Data } from "@singularsystems/neo-core";
export interface IPagerControlsProps extends React.HTMLProps<HTMLUListElement> {
    /** Page manager to control. */
    pageManager: Data.IPageManager;
    /** No of buttons to show */
    noOfButtons?: number;
    /** Alignment of buttons. End (right) by default. */
    alignment?: "start" | "center" | "end" | "";
    /** Text of the first button. */
    firstText?: string;
    /** Text of the prev button. */
    prevText?: string;
    /** Text of the next button. */
    nextText?: string;
    /** Text of the last button. */
    lastText?: string;
    /** Hides the pager if there is only one page. True by default. */
    autoHide?: boolean;
    /** Causes the page size control to show, with this label. */
    pageSizeLabel?: string | React.ReactNode;
}
export default class SimplePagerControls extends React.Component<IPagerControlsProps> {
    private iconFactory;
    render(): false | React.JSX.Element;
}
