import React from "react";
import { Components } from "@singularsystems/neo-core";
export interface IProgressBarProps {
    /**
     * Percentage completed. E.g. 0.5 for 50%.
     */
    progress?: number;
    /** Provide state from external component. E.g. TaskRunner */
    progressState?: Components.ProgressState;
    type?: "striped" | "animated";
    variant?: Components.variant;
    /** True if you want the animation to be reversed. */
    reverse?: boolean;
}
export default class ProgressBar extends React.Component<IProgressBarProps & React.HTMLProps<HTMLDivElement>> {
    innerRef: React.RefObject<HTMLDivElement | null>;
    componentDidMount(): void;
    render(): React.JSX.Element;
}
