/**
 * This component uses the rc-slider module
 * https://www.npmjs.com/package/rc-slider
 */
import React from 'react';
import { Model } from '@singularsystems/neo-core';
import type { SliderProps as ISliderLibProps } from 'rc-slider';
interface ICommonSliderProps {
    bind: Model.IPropertyInstance;
    onChangeEvent?: () => void;
}
interface ISliderSpecificProps extends ISliderLibProps, ICommonSliderProps {
}
interface IRangeSpecificProps extends ISliderLibProps, ICommonSliderProps {
    bindEnd: Model.IPropertyInstance;
}
export default class Slider extends React.Component<ISliderSpecificProps | IRangeSpecificProps> {
    private sliderImplementation;
    private get isRange();
    private get rangeProps();
    private get sliderProps();
    onChangeHandler: (value: number | number[]) => void;
    private getSlider;
    private getRange;
    render(): React.JSX.Element;
}
export {};
