/**
 * Watches all observables accessed during the getState callback.
 * When any of the value of these observables change, forceUpdate is called on the component.
 */
export declare class StateObserver<TState> {
    private component;
    private getState;
    private _disposer?;
    private inUpdate;
    isPaused: boolean;
    constructor(component: React.Component, getState: () => TState);
    observe(): void;
    dispose(): void;
}
