import { Components } from '@singularsystems/neo-core';
import React, { HTMLAttributes } from 'react';
export interface ITooltipProps extends Components.Tooltip.ITooltipOptions<string | React.ReactNode> {
    /**
     * True if the div wrapping the content must display inline.
     */
    inline?: boolean;
    children: React.ReactNode;
}
export default class Tooltip extends React.Component<ITooltipProps> {
    private divRef;
    private contentRef;
    constructor(props: ITooltipProps);
    componentWillUnmount(): void;
    private onMouseEnter;
    private onMouseLeave;
    render(): React.JSX.Element;
    static fromDataAttributes(element: React.ReactNode, attributes: {
        [key: string]: any;
    }): string | number | bigint | boolean | Iterable<React.ReactNode> | Promise<string | number | bigint | boolean | React.ReactPortal | React.ReactElement<unknown, string | React.JSXElementConstructor<any>> | Iterable<React.ReactNode> | null | undefined> | React.JSX.Element | null | undefined;
    static setDomProperties(dom: HTMLAttributes<HTMLElement> & {
        [key: string]: any;
    }, tooltipOptions: string | Components.Tooltip.ITooltipOptions): void;
    static hasTooltip(dom: HTMLAttributes<HTMLElement> & {
        [key: string]: any;
    }): boolean;
}
