import React from 'react';
export declare const containerId = "neo-toolip-container";
/**
 * The tooltip provider creates a single tooltip div.
 * This div is shown when the mouse pointer moves over any element which has a data-tip attribute.
 * The text value of the data-tip attribute will be shown in the tooltip.
 * Other properties are:
 * - data-tip-class: adds a class name.
 * - data-tip-html: specifies that the string value of data-tip should be rendered as html.
 * - data-tip-align: center by default, or start / end / start-edge / end-edge.
 * - data-tip-pos: top by default (if there is enough space). Can be set to bottom / left / right.
 */
export default class TooltipProvider extends React.Component {
    private currentInfo?;
    private observer;
    private timer;
    private lastElement;
    private domRef;
    constructor(props: {});
    componentDidMount(): void;
    componentWillUnmount(): void;
    private onAttributesChanged;
    private onMouseMove;
    private showHideOnElement;
    private afterTransitioned;
    private timerTick;
    private hide;
    private show;
    render(): React.JSX.Element;
}
