import React from "react";
import { TransitionController } from "./TransitionController";
import { Transition } from "./Transition";
export interface ITransitionContextState {
    controller: TransitionController;
}
export declare const TransitionContext: React.Context<ITransitionContextState>;
interface ITransitionContainerProps {
    controller?: TransitionController;
    transition?: Transition;
    /** Transition to use when going backwards. */
    backTransition?: Transition;
    children: React.ReactNode;
}
export default class TransitionContainer extends React.Component<ITransitionContainerProps> {
    private controller;
    private containerRef;
    private contextState;
    constructor(props: ITransitionContainerProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): React.JSX.Element;
}
export {};
