import { __extends } from "tslib";
import React from "react";
import { TransitionController } from "./TransitionController";
export var TransitionContext = React.createContext({ controller: new TransitionController() });
var TransitionContainer = /** @class */ (function (_super) {
    __extends(TransitionContainer, _super);
    function TransitionContainer(props) {
        var _this = _super.call(this, props) || this;
        _this.containerRef = React.createRef();
        if (!_this.props.controller) {
            _this.controller = new TransitionController(undefined, _this.props.transition, _this.props.backTransition);
            _this.controller.wasAutoCreated = true;
        }
        else {
            _this.controller = _this.props.controller;
            if (_this.props.transition) {
                _this.controller.defaultTransition = _this.props.transition;
            }
            if (_this.props.backTransition) {
                _this.controller.defaultBackTransition = _this.props.backTransition;
            }
        }
        _this.contextState = { controller: _this.controller };
        return _this;
    }
    TransitionContainer.prototype.componentDidMount = function () {
        if (this.containerRef.current) {
            this.controller.registerContainer(this.containerRef.current);
        }
    };
    TransitionContainer.prototype.componentWillUnmount = function () {
        this.controller.disposeContainer();
    };
    TransitionContainer.prototype.render = function () {
        return (React.createElement(TransitionContext.Provider, { value: this.contextState },
            React.createElement("div", { className: "neo-transition-container", ref: this.containerRef }, this.props.children)));
    };
    return TransitionContainer;
}(React.Component));
export default TransitionContainer;
