import { __decorate, __extends, __metadata } from "tslib";
import { computed, makeObservable } from "mobx";
import { observer } from "mobx-react";
import React from "react";
import { TransitionContext } from "./TransitionContainer";
import { Utils } from "@singularsystems/neo-core";
var TransitionPanel = /** @class */ (function (_super) {
    __extends(TransitionPanel, _super);
    function TransitionPanel(props) {
        var _a;
        var _this = _super.call(this, props) || this;
        _this.panelRef = React.createRef();
        makeObservable(_this);
        _this.name = (_a = _this.props.name) !== null && _a !== void 0 ? _a : Utils.uuidv4();
        return _this;
    }
    TransitionPanel.prototype.componentDidMount = function () {
        this.context.controller.registerPanel(this.name, this.props.isVisible !== undefined);
        this.afterRender();
    };
    TransitionPanel.prototype.componentDidUpdate = function () {
        this.afterRender();
    };
    TransitionPanel.prototype.afterRender = function () {
        if (this.props.isVisible) {
            this.context.controller.transition(this.name);
        }
        if (this.panelRef.current) {
            this.context.controller.afterUpdate(this.name, this.panelRef.current, this.props.transition, this.props.animateHeight);
        }
    };
    TransitionPanel.prototype.componentWillUnmount = function () {
        this.context.controller.disposePanel(this.name);
    };
    Object.defineProperty(TransitionPanel.prototype, "isVisible", {
        get: function () {
            return this.context.controller.isPanelVisible(this.name);
        },
        enumerable: false,
        configurable: true
    });
    TransitionPanel.prototype.render = function () {
        var _a = this.props, name = _a.name, data = _a.data, isVisible = _a.isVisible, animateHeight = _a.animateHeight, children = _a.children;
        if (data) {
            this.currentData = data;
        }
        else if (isVisible && typeof isVisible === "object") {
            this.currentData = isVisible;
        }
        return this.context.controller.isPanelVisible(this.name) ? (React.createElement("div", { ref: this.panelRef, className: "neo-transition-panel" }, typeof children === "function" ? (this.currentData ? children(this.currentData) : undefined) : children)) : undefined;
    };
    TransitionPanel.contextType = TransitionContext;
    __decorate([
        computed,
        __metadata("design:type", Object),
        __metadata("design:paramtypes", [])
    ], TransitionPanel.prototype, "isVisible", null);
    TransitionPanel = __decorate([
        observer,
        __metadata("design:paramtypes", [Object])
    ], TransitionPanel);
    return TransitionPanel;
}(React.Component));
export default TransitionPanel;
