import { __extends } from "tslib";
import React from "react";
import { TransitionController } from "./TransitionController";
import TransitionContainer from "./TransitionContainer";
import TransitionPanel from "./TransitionPanel";
var TransitionSwitcher = /** @class */ (function (_super) {
    __extends(TransitionSwitcher, _super);
    function TransitionSwitcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.componentA = null;
        _this.componentB = null;
        _this.transitionController = new TransitionController("A", _this.props.transition);
        return _this;
    }
    TransitionSwitcher.prototype.render = function () {
        var _a, _b;
        var component = this.props.children;
        if (typeof (component === null || component === void 0 ? void 0 : component.type) === "string") {
            throw "TransitionSwitcher can only have components as children.";
        }
        if (component && component.type === ((_a = this.componentA) === null || _a === void 0 ? void 0 : _a.type)) {
            if (this.transitionController.selectedPanel === "B") {
                this.transitionTo("A");
            }
        }
        else if (component && component.type === ((_b = this.componentB) === null || _b === void 0 ? void 0 : _b.type)) {
            if (this.transitionController.selectedPanel === "A") {
                this.transitionTo("B");
            }
        }
        else {
            if (this.transitionController.selectedPanel === "A") {
                this.componentB = component;
                this.transitionTo("B");
            }
            else {
                this.componentA = component;
                this.transitionTo("A");
            }
        }
        return React.createElement(TransitionContainer, { controller: this.transitionController },
            React.createElement(TransitionPanel, { name: "A" }, this.componentA),
            React.createElement(TransitionPanel, { name: "B" }, this.componentB));
    };
    TransitionSwitcher.prototype.transitionTo = function (panel) {
        if (this.props.forward !== false) {
            this.transitionController.forward(panel);
        }
        else {
            this.transitionController.back(panel);
        }
    };
    return TransitionSwitcher;
}(React.Component));
export default TransitionSwitcher;
