import React from 'react';
import { Model, Validation } from '@singularsystems/neo-core';
export interface IValidationSummaryProps {
    /**
     * Invalid object graph from Validation.getValidationSummary().
     * If this is null, 'model' must be specified.
     */
    graph?: Validation.IInvalidObjectGraph | Validation.IInvalidObjectGraph[] | null;
    /**
     * Model or list of models.
     * If this is null, 'graph' must be specified.
     */
    model?: Model.IModelBase | Model.IModelBase[];
    /**
     * True if the toString() title should be hidden on the top level.
     */
    hideTopLevelTitle?: boolean;
}
export default class ValidationSummary extends React.Component<IValidationSummaryProps> {
    private iconFactory;
    private getRules;
    render(): React.JSX.Element;
}
