export interface IRouteParameter {
    /** True if the parameter exists in the query string */
    isQuery?: boolean;
    /** True if the parameter is required for the route to match. Does not apply to query string parameters. */
    required?: boolean;
    /** Behaviour when this node is clicked on in the breadcrumb. Undefined is equivalent to BreadCrumbSelectMode.Default */
    selection?: BreadCrumbSelectMode;
}
export declare enum BreadCrumbSelectMode {
    /** Default behaviour, clicking this will clear the values of all child params. */
    Default = 0,
    /** Breadcrumb is not selectable. */
    None = 1,
    /** Clicking on the breadcrumb item will select the parent item. */
    SelectParent = 2
}
export type RouteParameters = {
    [index: string]: IRouteParameter;
};
export type RouteParameterObject<T> = {
    [P in keyof T]: IRouteParameter;
};
