import ViewBase from '../Views/ViewBase';
import { Routing } from '@singularsystems/neo-core';
import { RouteParameterObject } from './IRouteParameter';
export interface IMenuRoute extends Routing.IMenuRoute {
}
export declare class MenuRoute<TParams extends RouteParameterObject<TParams>> implements IMenuRoute {
    /**
     * Creates a menu route with view parameters specified.
     * @param baseRoute Path and component
     * @param menuParams Other menu options.
     * @param viewParams View parameter values.
     */
    constructor(baseRoute: {
        path: string;
        component: new (...args: any) => ViewBase<any, TParams>;
    }, menuParams: Routing.IMenuRoute, viewParams?: {
        [P in keyof TParams]?: number | string | null;
    });
    /** Path including view param values. */
    path: string;
    /** Path without parameter values or routing template. */
    basePath: string;
    /** Name to show in the menu item. */
    name: string;
}
