import { __awaiter, __decorate, __generator, __metadata, __param } from "tslib";
import { ModalUtils, Misc } from '@singularsystems/neo-core';
import { inject, injectable } from 'inversify';
import { NeoReactTypes } from '../Modules/Types';
import { RoutingState } from './RoutingState';
var PageLeaveHandler = /** @class */ (function () {
    function PageLeaveHandler(routingState) {
        this.routingState = routingState;
    }
    PageLeaveHandler.prototype.beforeLeavePage = function (changeProps) {
    };
    PageLeaveHandler.prototype.onLeavePage = function (view, leavePrompt) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(leavePrompt === false)) return [3 /*break*/, 1];
                        return [2 /*return*/, Promise.resolve(false)];
                    case 1:
                        if (!(typeof leavePrompt === "string")) return [3 /*break*/, 2];
                        return [2 /*return*/, this.showDefaultConfirmation(view, leavePrompt)];
                    case 2: return [4 /*yield*/, leavePrompt];
                    case 3:
                        result = _a.sent();
                        return [2 /*return*/, result === true || result === Misc.ModalResult.Yes];
                }
            });
        });
    };
    PageLeaveHandler.prototype.onWindowUnload = function (view, leavePrompt, e) {
        e.preventDefault();
        e.returnValue = typeof leavePrompt === "string" ? leavePrompt : "Are you sure you want to continue?";
    };
    PageLeaveHandler.prototype.showDefaultConfirmation = function (view, prompt) {
        var title = view ? view.viewName : "Un-saved Changes";
        return new Promise(function (resolve) {
            ModalUtils.showModal(title, prompt, {
                onClose: function () { return resolve(false); },
                acceptButton: { text: "Leave", onClick: function () { return resolve(true); } },
                closeButton: { text: "Stay", onClick: function () { return resolve(false); } }
            });
        });
    };
    PageLeaveHandler = __decorate([
        injectable(),
        __param(0, inject(NeoReactTypes.Routing.GlobalRoutingState.symbol)),
        __metadata("design:paramtypes", [RoutingState])
    ], PageLeaveHandler);
    return PageLeaveHandler;
}());
export { PageLeaveHandler };
