import * as React from 'react';
import { Routing } from '@singularsystems/neo-core';
import RouteProvider from './RouteProvider';
export default abstract class RouteView extends React.Component<unknown> {
    private routeProvider;
    private hasMounted;
    protected _routes: RouteProvider;
    protected getForbiddenComponent: (route: Routing.IRoute) => React.ReactNode;
    protected getSigningInComponent: (route: Routing.IRoute) => React.ReactNode;
    protected securityService: import("@singularsystems/neo-core/dist/Security/ISecurityService").default;
    protected routeSecurityService: Routing.IRouteSecurityService;
    protected routingState: import("./RoutingState").RoutingState;
    constructor(props: unknown, routeProvider: RouteProvider);
    componentDidMount(): void;
    render(): React.ReactNode;
    private getRouteComponent;
    /**
     * Creates the routes component after authentication and authorisation checks have been done.
     * This can be used to override all routes to display pages like terms and conditions.
     */
    protected getAuthorisedComponent(route: Routing.IRoute, path: string): React.ReactNode;
    /**
     * Checks if the user is authorised to access this route.
     * Component from getForbiddenComponent() is returned if not.
     */
    protected isAuthorised(route: Routing.IRoute): boolean;
}
