import { AppServices } from '@singularsystems/neo-core';
import { IViewBase } from '../Views/ViewBase';
import RouteProvider, { IMatchedRoute, IProcessedRoute } from './RouteProvider';
export declare class RoutingState {
    constructor(config: AppServices.IConfigModel);
    readonly basePath: string;
    appRouteProvider: RouteProvider;
    /** Gets the route which last matched */
    currentRoute: IMatchedRoute | null;
    /** Base route which last matched. This will not change when view parameters are updated. */
    currentRouteBase: IProcessedRoute | null;
    direction: number;
    /** Returns the current view instance. */
    currentView: IViewBase | null;
    get currentViewFullScreen(): boolean;
    get taskRunner(): import("@singularsystems/neo-core").ITaskRunner | undefined;
}
