import { Misc } from "@singularsystems/neo-core";
import { IReactionDisposer } from "mobx";
import { IDisposeHelper } from "./IDisposeHelper";
export declare class DisposeHelper implements IDisposeHelper {
    private registeredReactions;
    private registeredDisposables;
    /**
     * Registers a mobx reaction, which will be disposed in the dispose() method when the view is unmounted.
     * @param expression Expression to react to.
     * @param effect Callback to run when the result of the expression changes.
     */
    registerReaction<T>(expression: (vm: this) => T, effect: (value: T) => void): IReactionDisposer;
    autoDispose<T extends Misc.IDisposable>(disposable: T): T;
    dispose(): void;
}
