import ViewBase from "./ViewBase";
import { ViewState } from './ViewState';
import { RouteParameterObject } from '../Routing/IRouteParameter';
import { IViewModel } from './IViewModel';
export default abstract class PersistentViewBase<TViewModel extends IViewModel, TParams extends RouteParameterObject<TParams> = {}> extends ViewBase<TViewModel, TParams> {
    private static storedState;
    constructor(viewName: string, createViewModel: (() => TViewModel) | (new () => TViewModel), props: any);
    protected disposeViewModel(): void;
    getStoredViewState(viewModel: (() => TViewModel) | (new () => TViewModel)): ViewState<TViewModel, TParams>;
}
