import React from 'react';
import { ITaskRunner } from '@singularsystems/neo-core';
import { IViewModel } from './IViewModel';
import { valueOrLazy } from './ViewModelBase';
interface IComponentProps {
    taskRunner?: ITaskRunner;
}
export default class ViewComponentBase<TProps extends IComponentProps, TViewModel extends IViewModel> extends React.Component<TProps> {
    /**
     * Creates a view component.
     * @param props Component props.
     * @param viewModel Instance of view model, or view model type, or callback which returns a view model. Taskrunner will be set only if passing in VM type.
     */
    constructor(props: TProps, viewModel: valueOrLazy<TViewModel>);
    viewModel: TViewModel;
    componentDidMount(): void;
    componentWillUnmount(): void;
}
export {};
